<!-- components/Sidebar.vue -->

<template>
  <aside class="bg-lime-600 min-h-screen my-0 shadow-xl" :class="sidebarWidth">
    <div class="flex flex-col p-2 mb-4">
      <div class="flex mb-4" :class="sidebarVisible ? 'justify-end' : 'justify-center'">
        <button class="text-white hover:text-gray-300 px-2 py-1 mt-4" @click="toggleSidebar">
          <Icon size="25" class="w-full h-full" :name="'uis:bars'" />
        </button>
      </div>

      <ul :class="'space-y-2'">
        <template v-for="item in items">
          <li v-if="isShown(item.requiredRole)" class="flex my-0">
            <nuxt-link :to="item.path" :class="isSelected(item.path)"
              class="flex items-center w-full text-white rounded-lg text-center px-2 my-0 hover:text-gray-300 hover:bg-green-500 active:bg-green-600">
              <Icon size="25" :name="item.icon" />
              <span class="ml-2" :class="sidebarVisible ? '' : 'hidden'">
                {{ item.title }}
              </span>
            </nuxt-link>
          </li>
        </template>
      </ul>
    </div>
  </aside>
</template>

<script lang="ts">
interface sidebarMenu {
  title: string;
  path: string;
  icon: string;
  requiredRole: string;
}

export default {
  props: {
    items: Array<sidebarMenu>,
  },
  data() {
    return {
      sidebarVisible: true,
    };
  },
  methods: {
    toggleSidebar() {
      this.sidebarVisible = !this.sidebarVisible;
    },
    isShown(requiredRole: string) {
      const userData = useUserDataStore();
      const role = userData.role;
      if (role === 'admin') {
        return true;
      } else if (role === 'pabrik') {
        return requiredRole === 'admin' || requiredRole === 'penjualan' ? false : true;
      } else if (role === 'penjualan') {
        return requiredRole === 'admin' || requiredRole === 'pabrik' ? false : true;
      }
    },
    isSelected(path: string) {
      let classVal = "";
      const firstPathSegment = this.$route.path.split('/')[1];
      console.log(`${this.$route.path}   ${path}`)
      if (firstPathSegment == path.replace('/', '')) {
        classVal = this.sidebarVisible
          ? "bg-green-500 justify-start py-1"
          : "bg-green-500 justify-center py-3";
      } else {
        classVal = this.sidebarVisible
          ? "bg-transparent justify-start py-1"
          : "bg-transparent justify-center py-3";
      }
      return classVal;
    },
  },
  computed: {
    sidebarWidth() {
      return this.sidebarVisible ? "w-64" : "w-16";
    },
  },
};
</script>
